
package de.ivu.elect.presentation.wahlvorschlag.dokumente;

import static java.util.Arrays.asList;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.GroupedConversationScoped;

import de.ivu.elect.business.dokumente.boundary.AbstractDokumentGenerator;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlaegeDokumentContext;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlagMaengelDokumentGenerator;
import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@GroupedConversationScoped
@OnlineHilfeId("159")
@ConversationGroup(WahlvorschlagDokumentErzeugenView.class)
@Named(WahlvorschlagDokumentErzeugenView.COMPONENT_NAME)
@View(viewId = WahlvorschlagDokumentErzeugenView.VIEW_ID, useCase = UseCasePermission.DOKUMENT_ERZEUGEN_WAHLVORSCHLAG)
public class WahlvorschlagDokumentErzeugenView extends AbstractWahlvorschlagDokumentErzeugenView {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlvorschlagDokumentErzeugenView";

  public static final String VIEW_ID = "/wahlvorschlag/wahlvorschlag-dokument-erzeugen-view.xhtml";

  @Inject
  private transient WahlvorschlagMaengelDokumentGenerator wahlvorschlagMaengelDokumentGenerator;

  public WahlvorschlagDokumentErzeugenView() {
    super();
  }

  @Override
  public String getViewId() {
    return VIEW_ID;
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.DOKUMENT_ERZEUGEN_WAHLVORSCHLAG;
  }

  @Redirect
  public String initWahlvorschlag(Wahlvorschlag wahlvorschlag) {
    List<Wahlvorschlag> wahlvorschlaege = asList(wahlvorschlag);
    wahlvorschlaege.forEach(Wahlvorschlag::getPk); // ELECTMUC-660 einmal auf den PK zugreifen...

    return super.init((List) wahlvorschlaege); // Generics Quatsch
  }

  @Override
  protected AbstractDokumentGenerator<Object, WahlvorschlaegeDokumentContext> getDokumentGenerator() {
    return (AbstractDokumentGenerator) wahlvorschlagMaengelDokumentGenerator;
  }

  @Override
  protected void addDokumentParameterProperties(FormBuilder formBuilder) {
    // Add nothing...
  }

  @Override
  public boolean isSearchResultRendered() {
    return false; // ELECTMUC-2216, wird für einzelne Wahlvorschläge erzeugt, aber das Suchergebnis kann nicht danach gefiltert werden...
  }
}
